/*
 *
 * Artifactory is a binaries repository manager.
 * Copyright (C) 2018 JFrog Ltd.
 *
 * Artifactory is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 * Artifactory is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with Artifactory.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

package org.artifactory.metrics.services;

import org.junit.jupiter.params.ParameterizedTest;
import org.junit.jupiter.params.provider.MethodSource;
import org.testng.annotations.DataProvider;

import static org.testng.Assert.assertEquals;

/**
 * @author Tomer Mayost
 */
class CallHomeServiceTest {

    @ParameterizedTest
    @MethodSource("accountUrlExpectedAccountName")
    void checkCallHomeAccountName(String accountUrl, String expectedAccountName) {
        CallHomeService callHomeService = new CallHomeService();

        assertEquals(callHomeService.getAccountName(accountUrl), expectedAccountName);
    }

    @DataProvider
    private static Object[][] accountUrlExpectedAccountName() {
        return new Object[][] {
                {"https://bezirk.jfrog.io/bezirk/webapp/", "bezirk"},
                {"https://localhost:8080/artifactory/webapp/", "N/A"},
                {null, "N/A"}
        };
    }
}
