package org.artifactory.ui.rest.service.admin.security.keys.keypairs;

import com.google.common.collect.Maps;
import org.artifactory.addon.common.keys.KeyPairService;
import org.artifactory.api.config.CentralConfigService;
import org.artifactory.descriptor.config.MutableCentralConfigDescriptor;
import org.artifactory.descriptor.repo.FederatedRepoDescriptor;
import org.artifactory.descriptor.repo.KeyPairDescriptor;
import org.testng.annotations.Test;

import java.util.List;
import java.util.Map;

import static org.mockito.Mockito.mock;
import static org.mockito.Mockito.when;
import static org.testng.Assert.assertEquals;

/**
 * @author Alexei Vainshtein
 */
public class GetAllKeyPairsServiceTest {

    @Test
    public void testGetListOfReposPerKeyPair() {
        CentralConfigService centralConfigService = mock(CentralConfigService.class);
        MutableCentralConfigDescriptor descriptor = mock(MutableCentralConfigDescriptor.class);
        Map<String, FederatedRepoDescriptor> reposMap = Maps.newLinkedHashMap();
        String repoName = "repo";
        FederatedRepoDescriptor federatedRepo = new FederatedRepoDescriptor();
        KeyPairDescriptor keyPair = new KeyPairDescriptor();
        keyPair.setKey("key");
        federatedRepo.setPrimaryKeyPairDescriptor(keyPair);
        reposMap.put(repoName, federatedRepo);
        when(descriptor.getFederatedRepositoriesMap()).thenReturn(reposMap);
        when(centralConfigService.getMutableDescriptor()).thenReturn(descriptor);
        GetAllKeyPairsService service = new GetAllKeyPairsService(centralConfigService, mock(KeyPairService.class));
        List<String> keys = service.getListOfReposPerKeyPair("key");
        assertEquals(keys.size(), reposMap.size());
    }
}